function X=LU_solve_gen(A,B)
% Funzione per risolvere l'equazione matriciale AX=B

%Input:
% A, B matrici 

%Output:
% X matrice soluzione del sistema AX=B


% L,U,P matrici restituite dal comando lu
[L,U,P]=lu(A);

% Prima versione
[m,m]=size(A);
[m n]=size(B);
for i=1:n
    Y(:,i)=L\(P*B(:,i));
    X(:,i)=U\Y(:,i);
    %oppure in un unico comando
    %X(:,i)=U\(L\(P*B(:,i)));
end

% Versione alternatva
% Y=L\(P*B);
% X=U\Y;
% %o semplicemente 
% %X=U\(L\(P*B));